diff --git a/include/dt-bindings/clock/microchip,sam9x60-pmc.h b/include/dt-bindings/clock/microchip,sam9x60-pmc.h
new file mode 100644
index 0000000000000..e01e867e8c4da
--- /dev/null
+++ b/include/dt-bindings/clock/microchip,sam9x60-pmc.h
@@ -0,0 +1,19 @@
+/* SPDX-License-Identifier: GPL-2.0-only OR BSD-2-Clause */
+/*
+ * The constants defined in this header are being used in dts and in
+ * at91 sam9x60 clock driver.
+ */
+
+#ifndef _DT_BINDINGS_CLOCK_MICROCHIP_SAM9X60_PMC_H
+#define _DT_BINDINGS_CLOCK_MICROCHIP_SAM9X60_PMC_H
+
+#include <dt-bindings/clock/at91.h>
+
+/* old from before bindings splitup */
+#define SAM9X60_PMC_MCK		PMC_MCK		/* 1 */
+#define SAM9X60_PMC_UTMI	PMC_UTMI	/* 2 */
+#define SAM9X60_PMC_MAIN	PMC_MAIN	/* 3 */
+
+#define SAM9X60_PMC_PLLACK	PMC_PLLACK	/* 7 */
+
+#endif
diff --git a/include/dt-bindings/clock/microchip,sam9x7-pmc.h b/include/dt-bindings/clock/microchip,sam9x7-pmc.h
new file mode 100644
index 0000000000000..2df1ff97a5b18
--- /dev/null
+++ b/include/dt-bindings/clock/microchip,sam9x7-pmc.h
@@ -0,0 +1,25 @@
+/* SPDX-License-Identifier: GPL-2.0-only OR BSD-2-Clause */
+/*
+ * The constants defined in this header are being used in dts and in
+ * at91 sam9x7 clock driver.
+ */
+
+#ifndef _DT_BINDINGS_CLOCK_MICROCHIP_SAM9X7_PMC_H
+#define _DT_BINDINGS_CLOCK_MICROCHIP_SAM9X7_PMC_H
+
+#include <dt-bindings/clock/at91.h>
+
+/* old from before bindings splitup */
+#define SAM9X7_PMC_MCK		PMC_MCK		/* 1 */
+#define SAM9X7_PMC_UTMI		PMC_UTMI	/* 2 */
+#define SAM9X7_PMC_MAIN		PMC_MAIN	/* 3 */
+
+#define SAM9X7_PMC_PLLACK	PMC_PLLACK	/* 7 */
+
+#define SAM9X7_PMC_AUDIOPMCPLL	PMC_AUDIOPMCPLL	/* 9 */
+#define SAM9X7_PMC_AUDIOIOPLL	PMC_AUDIOIOPLL	/* 10 */
+
+#define SAM9X7_PMC_PLLADIV2	PMC_PLLADIV2	/* 14 */
+#define SAM9X7_PMC_LVDSPLL	PMC_LVDSPLL	/* 15 */
+
+#endif
diff --git a/include/dt-bindings/clock/microchip,sama7d65-pmc.h b/include/dt-bindings/clock/microchip,sama7d65-pmc.h
new file mode 100644
index 0000000000000..f5be643be9b36
--- /dev/null
+++ b/include/dt-bindings/clock/microchip,sama7d65-pmc.h
@@ -0,0 +1,32 @@
+/* SPDX-License-Identifier: GPL-2.0-only OR BSD-2-Clause */
+/*
+ * The constants defined in this header are being used in dts and in
+ * at91 sama7d65 clock driver.
+ */
+
+#ifndef _DT_BINDINGS_CLOCK_MICROCHIP_SAMA7D65_PMC_H
+#define _DT_BINDINGS_CLOCK_MICROCHIP_SAMA7D65_PMC_H
+
+#include <dt-bindings/clock/at91.h>
+
+/* old from before bindings splitup */
+#define SAMA7D65_PMC_MCK0		PMC_MCK		/* 1 */
+#define SAMA7D65_PMC_UTMI		PMC_UTMI	/* 2 */
+#define SAMA7D65_PMC_MAIN		PMC_MAIN	/* 3 */
+#define SAMA7D65_PMC_CPUPLL		PMC_CPUPLL	/* 4 */
+#define SAMA7D65_PMC_SYSPLL		PMC_SYSPLL	/* 5 */
+
+#define SAMA7D65_PMC_BAUDPLL		PMC_BAUDPLL	/* 8 */
+#define SAMA7D65_PMC_AUDIOPMCPLL	PMC_AUDIOPMCPLL	/* 9 */
+#define SAMA7D65_PMC_AUDIOIOPLL		PMC_AUDIOIOPLL	/* 10 */
+#define SAMA7D65_PMC_ETHPLL		PMC_ETHPLL	/* 11 */
+
+#define SAMA7D65_PMC_MCK1		PMC_MCK1	/* 13 */
+
+#define SAMA7D65_PMC_LVDSPLL		PMC_LVDSPLL	/* 15 */
+#define SAMA7D65_PMC_MCK3		PMC_MCK3	/* 16 */
+#define SAMA7D65_PMC_MCK5		PMC_MCK5	/* 17 */
+
+#define SAMA7D65_PMC_INDEX_MAX		25
+
+#endif
diff --git a/include/dt-bindings/clock/microchip,sama7g5-pmc.h b/include/dt-bindings/clock/microchip,sama7g5-pmc.h
new file mode 100644
index 0000000000000..ad69ccdf9dc78
--- /dev/null
+++ b/include/dt-bindings/clock/microchip,sama7g5-pmc.h
@@ -0,0 +1,24 @@
+/* SPDX-License-Identifier: GPL-2.0-only OR BSD-2-Clause */
+/*
+ * The constants defined in this header are being used in dts and in
+ * at91 sama7g5 clock driver.
+ */
+
+#ifndef _DT_BINDINGS_CLOCK_MICROCHIP_SAMA7G5_PMC_H
+#define _DT_BINDINGS_CLOCK_MICROCHIP_SAMA7G5_PMC_H
+
+#include <dt-bindings/clock/at91.h>
+
+/* old from before bindings splitup */
+#define SAMA7G5_PMC_MCK0	PMC_MCK		/* 1 */
+#define SAMA7G5_PMC_UTMI	PMC_UTMI	/* 2 */
+#define SAMA7G5_PMC_MAIN	PMC_MAIN	/* 3 */
+#define SAMA7G5_PMC_CPUPLL	PMC_CPUPLL	/* 4 */
+#define SAMA7G5_PMC_SYSPLL	PMC_SYSPLL	/* 5 */
+
+#define SAMA7G5_PMC_AUDIOPMCPLL	PMC_AUDIOPMCPLL	/* 9 */
+#define SAMA7G5_PMC_AUDIOIOPLL	PMC_AUDIOIOPLL	/* 10 */
+
+#define SAMA7G5_PMC_MCK1	PMC_MCK1	/* 13 */
+
+#endif